/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
)

// checks if the LoyaltyPointsChange type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LoyaltyPointsChange{}

// LoyaltyPointsChange struct for LoyaltyPointsChange
type LoyaltyPointsChange struct {
	Name string `json:"name"`
	Amount int32 `json:"amount"`
	ChangeType string `json:"change_type"`
	ContactId string `json:"contact_id"`
	ChannelId string `json:"channel_id"`
	OrganizationId string `json:"organization_id"`
	ConversationId string `json:"conversation_id"`
}

// NewLoyaltyPointsChange instantiates a new LoyaltyPointsChange object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLoyaltyPointsChange(name string, amount int32, changeType string, contactId string, channelId string, organizationId string, conversationId string) *LoyaltyPointsChange {
	this := LoyaltyPointsChange{}
	this.Name = name
	this.Amount = amount
	this.ChangeType = changeType
	this.ContactId = contactId
	this.ChannelId = channelId
	this.OrganizationId = organizationId
	this.ConversationId = conversationId
	return &this
}

// NewLoyaltyPointsChangeWithDefaults instantiates a new LoyaltyPointsChange object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLoyaltyPointsChangeWithDefaults() *LoyaltyPointsChange {
	this := LoyaltyPointsChange{}
	return &this
}

// GetName returns the Name field value
func (o *LoyaltyPointsChange) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPointsChange) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *LoyaltyPointsChange) SetName(v string) {
	o.Name = v
}

// GetAmount returns the Amount field value
func (o *LoyaltyPointsChange) GetAmount() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Amount
}

// GetAmountOk returns a tuple with the Amount field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPointsChange) GetAmountOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Amount, true
}

// SetAmount sets field value
func (o *LoyaltyPointsChange) SetAmount(v int32) {
	o.Amount = v
}

// GetChangeType returns the ChangeType field value
func (o *LoyaltyPointsChange) GetChangeType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChangeType
}

// GetChangeTypeOk returns a tuple with the ChangeType field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPointsChange) GetChangeTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChangeType, true
}

// SetChangeType sets field value
func (o *LoyaltyPointsChange) SetChangeType(v string) {
	o.ChangeType = v
}

// GetContactId returns the ContactId field value
func (o *LoyaltyPointsChange) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPointsChange) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *LoyaltyPointsChange) SetContactId(v string) {
	o.ContactId = v
}

// GetChannelId returns the ChannelId field value
func (o *LoyaltyPointsChange) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPointsChange) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *LoyaltyPointsChange) SetChannelId(v string) {
	o.ChannelId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *LoyaltyPointsChange) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPointsChange) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *LoyaltyPointsChange) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetConversationId returns the ConversationId field value
func (o *LoyaltyPointsChange) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *LoyaltyPointsChange) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *LoyaltyPointsChange) SetConversationId(v string) {
	o.ConversationId = v
}

func (o LoyaltyPointsChange) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LoyaltyPointsChange) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["amount"] = o.Amount
	toSerialize["change_type"] = o.ChangeType
	toSerialize["contact_id"] = o.ContactId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["conversation_id"] = o.ConversationId
	return toSerialize, nil
}

type NullableLoyaltyPointsChange struct {
	value *LoyaltyPointsChange
	isSet bool
}

func (v NullableLoyaltyPointsChange) Get() *LoyaltyPointsChange {
	return v.value
}

func (v *NullableLoyaltyPointsChange) Set(val *LoyaltyPointsChange) {
	v.value = val
	v.isSet = true
}

func (v NullableLoyaltyPointsChange) IsSet() bool {
	return v.isSet
}

func (v *NullableLoyaltyPointsChange) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLoyaltyPointsChange(val *LoyaltyPointsChange) *NullableLoyaltyPointsChange {
	return &NullableLoyaltyPointsChange{value: val, isSet: true}
}

func (v NullableLoyaltyPointsChange) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLoyaltyPointsChange) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


